﻿Public Class Form1
    Dim _activeDR As DataRow
    Dim WithEvents dt As New DataTable("Customers")
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        dt.Columns.Add("TR_F_ID", GetType(Integer))
        dt.Columns.Add("TR_C_ID", GetType(Integer))
        dt.Columns.Add("TR_LEVEL", GetType(Integer))
        dt.Columns.Add("TR_PARENT_F_ID", GetType(Integer))
        dt.Columns.Add("F_NAME", GetType(String))
        dt.Rows.Add(1, 101, 1, 2, "Test1")
        dt.Rows.Add(2, 105, 3, 1, "Test2")
        dt.Rows.Add(3, 102, 2, 2, "Test3")
        dt.Rows.Add(4, 105, 2, 3, "Test4")
        dt.Rows.Add(5, 100, 4, 2, "Test5")
        dt.Rows.Add(6, 102, 2, 4, "Test6")
        dt.Rows.Add(7, 105, 3, 3, "Test7")
        dt.Rows.Add(8, 101, 3, 1, "Test8")

        C1TreeView1.BindingInfo.DataSource = dt

        C1TreeView1.Columns(0).DisplayFieldName = "F_NAME\F_NAME"
        C1TreeView1.Columns(0).HeaderText = "Display Name"

        Dim column = New C1.Win.TreeView.C1TreeColumn()
        column.DisplayFieldName = "TR_C_ID\TR_C_ID"
        column.HeaderText = "Class ID"
        column.Visible = False
        C1TreeView1.Columns.Add(column)

        column = New C1.Win.TreeView.C1TreeColumn()
        column.DisplayFieldName = "TR_LEVEL\TR_LEVEL"
        column.HeaderText = "Level Number"
        C1TreeView1.Columns.Add(column)

        column = New C1.Win.TreeView.C1TreeColumn()
        column.DisplayFieldName = "TR_PARENT_F_ID\TR_PARENT_F_ID"
        column.HeaderText = "Parent ID"
        C1TreeView1.Columns.Add(column)
        column = New C1.Win.TreeView.C1TreeColumn()
        column.DisplayFieldName = "TR_F_ID\TR_F_ID"
        column.HeaderText = "ID"
        C1TreeView1.Columns.Add(column)

        C1TreeView1.AllowEditing = True
        C1TreeView1.EditMode = C1.Win.TreeView.C1TreeViewEditMode.EditOnKeystrokeOrF2
    End Sub
    Private Sub Dt_TableNewRow(sender As Object, e As DataRowChangeEventArgs) Handles dt.RowChanged
        If e.Action = DataRowAction.Add And flag Then
            C1TreeView1.Nodes(C1TreeView1.Nodes.Count - 1).Selected = True
            'Dim obj As Object = C1TreeView1.FocusedElement
            'obj.GetType().GetProperty("Node").SetValue(obj, C1TreeView1.SelectedNodes(0))
            'Dim node As C1.Win.TreeView.C1TreeNode = obj.GetType().GetProperty("Node").GetValue(obj)
            'Debug.WriteLine(node.GetValue(0))
            flag = False
        End If
    End Sub
    Dim flag As Boolean = False
    Private Sub C1TreeView1_MouseDown(sender As Object, e As MouseEventArgs) Handles C1TreeView1.MouseDown
        If e.Button = MouseButtons.Left Then
            _activeDR = C1TreeView1.SelectedNodes(0).GetValue()
        End If
        If e.Button = MouseButtons.Right Then
            Dim _newDR As DataRow = DirectCast(C1TreeView1.BindingInfo.DataSource, DataTable).NewRow()
            _newDR("F_NAME") = "New Folder"
            If _activeDR IsNot Nothing Then
                _newDR("TR_LEVEL") = CInt(_activeDR("TR_LEVEL")) + 1
                _newDR("TR_PARENT_F_ID") = CInt(_activeDR("TR_F_ID"))
            End If
            _newDR("TR_F_ID") = -1
            flag = True
            DirectCast(C1TreeView1.BindingInfo.DataSource, DataTable).Rows.Add(_newDR)
        End If
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        For Each nd As C1.Win.TreeView.C1TreeNode In C1TreeView1.Nodes
            'If nd.GetValue(1) = "100" Then
            '    nd.Selected = True
            'End If
            If CType(nd.GetValue(), DataRow) IsNot Nothing Then
                Dim row = CType(nd.GetValue(), DataRow)
                If row("TR_C_ID") = "100" Then
                    nd.Selected = True
                End If
            End If
        Next
    End Sub
End Class
